#include <stdio.h>
#include <stdlib.h>

char get_pes();

FILE * in_file = NULL;
FILE * out_file = NULL;

void syntax() {
	fprintf(stdout, "usage: \n\tps2pva -i [inputfile | -] -o [outputfile | -] \n\t where '-' selects /dev/stdin or /dev/stdout as input or output file\n");
}

int main(int argc, char ** argv) {
	char * in_string = NULL;
	char * out_string = NULL;
	int i;
	char input_flag = 0;
	char output_flag = 0;
	
	for(i = 1; i < argc; i++) {
		if (argv[i][0] == '-') {
			if (argv[i][1] == 'i') input_flag = 1;
			else if (argv[i][1] == 'o') output_flag = 1;
			else if (argv[i][1] == 0) {
				if(input_flag) in_string = "/dev/stdin";
				if(output_flag) out_string = "/dev/stdout";
			}
			else {
				fprintf(stderr, "unknown option %s\n", argv[i]);
				syntax();
				exit(-2);
			}
		}
		else {
			if (input_flag) {
				in_string = argv[i];
				input_flag = 0;
			}
			if (output_flag) {
				out_string = argv[i];
				output_flag = 0;
			}
		}
	}
	
	if ((in_string == out_string) || (in_string == NULL) || (out_string == NULL)) {
		syntax();
		exit(-2);
	}
	
	if (!(in_file = fopen(in_string, "r"))) {
		fprintf(stderr, "could not open input file %s\n", in_string);
		exit(-1);
	}
	if (!(out_file = fopen(out_string, "w"))) {
		fprintf(stderr, "could not open output file %s\n", out_string);
		exit(-1);
	}
	while(get_pes());
	return 0;
}
