#include <stdio.h>
#include <stdlib.h> 
#include <string.h> 
#include <netinet/in.h>
/* later use kmalloc instead of malloc and kernel headers instead of libc! */

typedef unsigned char u8;
typedef unsigned short int u16;
/* there is some header defining these, but i don't know which... */

u8 transmit_pva(const u8 * const, u16);

typedef struct pva_remaining_s {
	u8 pre_bytes_num;
	u8 a_count;
	u8 v_count;
	u8 pre_bytes[4];
	u8 buff[6144];
} pva_remaining;
	
pva_remaining * desc = NULL;

void build_pva(u8 * pes) {
	if (!desc) {
		desc = (pva_remaining *) malloc(sizeof(pva_remaining));
		desc->pre_bytes_num = 0;
		desc->a_count = 255;
		desc->v_count = 255;
		desc->buff[0] = 'A';
		desc->buff[1] = 'V';
		desc->buff[4] = 0x55;
		
	}
	u16 max_length = 0;
	u16 pva_length = 0;
	u16 pva_length_n = 0;
	u16 pes_remaining = 0;
	u16 pes_pos = 0;
	u16 pva_pos = 0;
	u8 * const pva = desc->buff;
	
	/*first pva packet contains pts and such*/
	
	if ((pes[3] & 0xf0) == 0xe0) {
		
		
		pva[2] = 0x01;
		pva[3] = desc->v_count;
		max_length = 6144;
		if (pes[7] & 0xc0) {

			
			pva[5] = 0x10;  /*building pts*/
			pva[8] = (pes[9] << 5) & 0xc0;
			pva[8] |= pes[10] >> 2;
			pva[9] = (pes[10] << 6) & 0xc0;
			pva[9] |= pes[11] >> 2;
			pva[10] = (pes[11] << 6) & 0x80;
			pva[10] |= pes[12] >> 1;
			pva[11] = (pes[12] << 7) & 0x80;
			pva[11] |= pes[13] >> 1;
			pva_pos = 12;
		}
		else {
			pva_pos = 8;
			pva[5] = 0;
		}
		if (desc->pre_bytes_num) {

			
			pva[5] |= desc->pre_bytes_num;
			memcpy(&(pva[pva_pos]), desc->pre_bytes, desc->pre_bytes_num);
			pva_pos += desc->pre_bytes_num;
			desc->pre_bytes_num = 0;
		}
		pes_pos = 9 + pes[8];
	}
	else {
		pva[2] = 0x02;
		max_length = 2048;
		pva[3] = desc->a_count;
		pva[5] = 0x10;
		pva_pos = 8;
	}
	
	if (pva[3] == 255) pva[3] = 0;
	else (pva[3])++;
	pes_remaining = pes[4]; 
	pes_remaining *= 256; 
	pes_remaining += pes[5]; 
	pes_remaining = pes_remaining - pes_pos + 6; /* because the first 6 bytes are not counted in the pes */
	if (!pes_remaining) return; /* null packet - we can't handle it */
	
	if (pes_remaining <= max_length - pva_pos) {
		pva_length = pes_remaining + pva_pos;
		if (pva[2] == 0x01) {
			pva_length = (pva_length / 4) * 4;
			desc->pre_bytes_num = pes_remaining - pva_length + pva_pos;
			if (pes_remaining >= desc->pre_bytes_num) {
				memcpy(desc->pre_bytes, &(pes[pes_pos + pes_remaining - desc->pre_bytes_num]), desc->pre_bytes_num);
				pes_remaining -= desc->pre_bytes_num;
			}
			else {
				fprintf(stderr, "weird packet, discarding\n");
				return;
			}
			pva[5] |= desc->pre_bytes_num << 2;
		}
	}
	else {
		pva_length = max_length;
	}
	
	pva_length_n = htons(pva_length - 8);
	memcpy(&(pva[6]), &pva_length_n, 2);
	memcpy(&(pva[pva_pos]), &(pes[pes_pos]), (pva_length - pva_pos));
	pes_pos += (pva_length - pva_pos);
	pes_remaining = pes_remaining - pva_length + pva_pos;
	transmit_pva(pva, pva_length);
	pva[5] = 0x00; /*delete pts_flag*/

	while(pes_remaining) {
		if (pes_remaining > max_length - 8) {
			pva_length = max_length;
		}
		else {
			pva_length = pes_remaining + 8; 
			if (pva[2] == 0x01) { /*dword align*/
				pva_length = (pva_length / 4) * 4;
				desc->pre_bytes_num = pes_remaining - pva_length + 8;
				memcpy(desc->pre_bytes, &(pes[pes_pos + pes_remaining - desc->pre_bytes_num]), desc->pre_bytes_num);
				pes_remaining -= desc->pre_bytes_num;
				pva[5] |= desc->pre_bytes_num << 2;
			}
		}
		pva_length_n = htons(pva_length - 8);
			
		pes_remaining = pes_remaining - pva_length + 8;
		
		if (pva[3] == 255) pva[3] = 0;
		else pva[3]++;

		memcpy(&(pva[6]), &pva_length_n, 2);

		memcpy(&(pva[8]), &(pes[pes_pos]), pva_length - 8);
		pes_pos += (pva_length - 8);
		transmit_pva(pva, pva_length);
	}
	if(pva[2] == 0x01) desc->v_count = pva[3]; /* rescue the counter */
	else desc->a_count = pva[3];
}
