#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <netinet/in.h>

typedef char u8;
typedef unsigned short int u16;

void build_pva(u8 * pes);

extern FILE * out_file;
extern FILE * in_file;

u16 buff_length = 0;
u8 * pes = NULL;
	
u8 get_pes() {
	int test_eof = 0;
	u16 pes_pos = 0;
	u16 pes_length = 0;
	u16 pes_length_n = 0;
	u8 stream_id;


	while((test_eof = fgetc(in_file)) != EOF) {
		if (test_eof == 0x00) {
			if ((fgetc(in_file)) == 0x00) {
				if ((fgetc(in_file)) == 0x01) {
					stream_id = fgetc(in_file);
					
					
					pes_length = fgetc(in_file) * 256;
					pes_length += fgetc(in_file);
					pes_length += 6;
					
					if ((stream_id >= 0xc0) && (stream_id < 0xe0 + 0x10)) { 
						/*fprintf(stderr, "audio or viedeo packet found, stream_id: %X", stream_id);*/
						if (pes_length >= 9) break; 
						else fprintf(stderr, "discarding a packet of length < 9\n");
						/* packets without specified length are discarded... might be a problem */
					}
					

					/* pack header - throw away */
					else if (stream_id == 0xba) {
						/*fprintf(stderr, "pack_header found\n");*/
						continue;
					}
					
					/* end of stream */
					else if (stream_id == 0xb9) return 0;
					
					else {
						pes_length -= 6; 
						while(pes_length) {
							fgetc(in_file);
							pes_length--;
						}
						continue;
						/* some other packet - kick it */
					}
				}
			}
		}
		/*else fprintf(stderr, "didn't get pes start: %X\n", test_eof);*/
	}
	if (test_eof == EOF) return 0;
	else {
		if (buff_length < pes_length) {
			pes = (u8 *)realloc(pes, pes_length);
			buff_length = pes_length;
		}
		pes[0] = 0x00; /*packet_start_code_prefix */
		pes[1] = 0x00;
		pes[2] = 0x01;
		pes[3] = stream_id;
		pes_length_n = htons(pes_length - 6);
		memcpy(&(pes[4]), &pes_length_n, 2);
		for(pes_pos = 6; pes_pos < pes_length; pes_pos++) pes[pes_pos] = fgetc(in_file);
		build_pva(pes);
		return 1;
	}
}

u8 transmit_pva(const u8 * const pva, u16 length) {
	u16 i = 0;
	for (i = 0; i < length; i++) {
		if(fputc(pva[i], out_file) == EOF) return 0;
	}
	return 1;
	
}
		
		
		
		
		
		
		

						
	
		

